require 'faraday'
require 'json'

class Utils
    def initialize(username, password)
        @ca_pem = ENV['DS_CA_PEM'] || './ca-cert.pem'
        @host = ENV['DS_HOST'] || 'localhost'
        @port = ENV['DS_PORT'] || 8443
        @username = username
        @password = password
    end

    def ca_pem
        @ca_pem
    end

    def host
        @host
    end

    def port
        @port
    end

    def authenticate
        query = { '_action': 'authenticate' }
        options = { ca_file: @ca_pem }
        hdap = Faraday.new(url: "https://#{@host}:#{@port}/hdap/", params: query, ssl: options) do |f|
            f.headers['Content-Type'] = 'application/json'
        end
        response = hdap.post do |h|
            h.path = "#{@username}"
            h.body = JSON.generate({ "password" => @password })
        end
        JSON.parse(response.body)['access_token']
    end
end
